// MainFrm.h : interface of the CClock class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef CLOCK_H
#define CLOCK_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define WM_CLOCKTIMETICK    (WM_USER+100)
#define CLOCK_COLOR1        RGB(0, 0, 192)
#define CLOCK_COLOR2        RGB(0, 0, 192)
//#define CLOCK_COLOR2      RGB(255, 255, 255)

#define CAL_CLASS_NAME          "Desktop Calendar Ver 1.0"
#define WINDOW_NAME             "Calendar"
#define CAL_TIMER               0x01

#define NO_CHANGE               0
#define DAY_CHANGE              1
#define CHANGE_ALL              2
#define CAL_UPDATE              3333

typedef struct _MZDrawObj
{
    int xPos;
    int yPos;
    char cType;
} MZDrawObj;

class CClock : public CWnd
{
    // Attributes
public:
    DWORD dwThreadId;
    COLORREF m_objColor;
    COLORREF m_dotColor;
    HPEN m_bkPen;
    HPEN m_bkDotPen;
    MZDrawObj m_obj[4][7];
    HRGN m_hWndRgn;
    int m_nHour;
    int m_nMin;
    WORD m_objHour[24];
    WORD m_objMin[60];
    int iDisplayClock;  // Display clock
    int iXPosClock;     // Starting location X
    int iYPosClock;     // Starting location Y
public:
    void Start();
    int CheckDate();
public:
    CClock();
protected:
    DECLARE_DYNAMIC(CClock)
    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CClock)
    public:
    void ReadRegistry();
    void WriteRegistry();
    void ShowWindowClock(int displayclock);
    virtual BOOL DestroyWindow();
    void DefineWndRegion(BOOL bRedraw);
    void InitDrawObj();
    void DrawDot(HDC hdc, int xPos, int yPos);
    void AddDotRegio(int xPos, int yPos);
    void AddRegion(int idx1, int idx2);
    void DrawObj(HDC hdc, int idx1, int idx2);
    void DrawMin(HDC hdc, WORD wHour);
    void DrawHour(HDC hdc, WORD wHour);
    void DrawTime(HDC hdc, int nHour, int nMin);
    void OnTimeTick();
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CClock();


    // Generated message map functions
protected:
    //{{AFX_MSG(CClock)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnTimer(UINT nIDEvent);
    afx_msg void OnTimeChange();
    afx_msg void OnCalAboutbox();
    afx_msg void OnCalOptions();
    afx_msg void OnCalUpdate();
    afx_msg void OnPaint();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

extern CClock* pFrame;

#endif
