// AboutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "aaeroint.h"
#include <windowsx.h>
#include "AboutDlg.h"
#include "MainHelperQ.h"
#include "AutoUpdater.h"
#include "version.ver"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CAboutDlg* AboutDialog = NULL;

CWhatNewDlg::CWhatNewDlg() : CDialog(IDD_WHATNEW)
{
    text.LoadString(AfxGetInstanceHandle(), IDS_WHATNEW);
    text.Replace(_T("\n \n"), _T("\n"));
    text.Replace(_T("\r"), _T(""));
    text.Replace(_T("\n"), _T("\r\n"));
    text = text.Mid(text.Find(_T("[")));
}

BOOL CWhatNewDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_WHATNEW);
    GetDlgItem(IDC_WHAT)->SetWindowText(text);
    return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog


CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    CString strCredits = _T("\tDesktop Calendar\n")
    _T("\rVersion 2010\n\n")
    _T("\r 2004 - 2010\n")
    _T("\b Mickal Sebire - Lyon, France\n\n")
    _T("  Inspired by some projects from http://www.codeproject.com\n")
    _T("    http://www.codeproject.com/KB/cpp/Desktop_Calendar.aspx\n")
    _T("    http://www.codeproject.com/KB/applications/wallpaperq.aspx\n")
    _T("    http://www.codeproject.com/KB/dialog/AOTop.aspx\n")
    _T("    http://www.codeproject.com/KB/miscctrl/transclock1.aspx\n")
    _T("    http://www.codeproject.com/KB/static/aboutctrl.aspx\n\n")
    ;
    strCredits += m_Helper.MyLoadString(IDS_CREDIT);

    m_AboutCtrl.SetCredits(strCredits);
}

CAboutDlg::~CAboutDlg()
{
    AboutDialog = NULL;
}

CAboutDlg* CAboutDlg::GetInstance()
{
    if (AboutDialog != NULL && AboutDialog->m_hWnd != NULL)
        AboutDialog->DestroyWindow();
    if (AboutDialog != NULL && AboutDialog->m_hWnd == NULL)
    {
        delete AboutDialog;
        AboutDialog = NULL;
    }
    if (AboutDialog == NULL)
    {
        AboutDialog = new CAboutDlg();
        AboutDialog->Create(CAboutDlg::IDD);
    }
    else
        AboutDialog->SetFocus();
    return AboutDialog;
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
  ON_BN_CLICKED(IDC_BUTTON_MAIL, OnButtonMail)
  ON_WM_CLOSE()
  ON_BN_CLICKED(IDC_BUTTON_HOMEPAGE, OnButtonHomepage)
  ON_BN_CLICKED(IDC_BUTTON_UPDATENOW, OnButtonUpdateNow)
  ON_BN_CLICKED(IDC_BUTTON_WHATNEW, OnButtonWhatNew)
  ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg message handlers

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_BUTTON_HOMEPAGE, m_btnInternet);
    DDX_Control(pDX, IDC_BUTTON_MAIL, m_btnMail);
    DDX_Control(pDX, IDC_BUTTON_UPDATENOW, m_btnUpdateNow);
    DDX_Control(pDX, IDC_BUTTON_WHATNEW, m_btnWhatNew);
    DDX_Control(pDX, IDOK, m_btnOk);
    DDX_Control(pDX, IDC_ABOUTCTRL, m_AboutCtrl);
}
void CAboutDlg::OnButtonHomepage()
{
    ShellExecute(NULL, _T("open"), _T("http://systrayplay.free.fr/"), NULL, NULL, SW_SHOWNORMAL);
}
void CAboutDlg::OnButtonMail()
{
    ShellExecute(NULL, NULL, _T("mailto:micksebire@yahoo.fr"), NULL, NULL, SW_SHOWNORMAL);
}
void CAboutDlg::OnButtonUpdateNow()
{
    CString buf;
    CAutoUpdater updater;
    CAutoUpdater::ErrorType err = updater.CheckForUpdate(_T("http://systrayplay.free.fr/"));
    switch (err)
    {
        case CAutoUpdater::Success:
            buf = m_Helper.MyLoadString(IDS_UPDATEOK);
            AfxMessageBox(buf, MB_ICONINFORMATION | MB_OK);
            SendMessage(WM_CLOSE);
            break;
        case CAutoUpdater::UpdateNotRequired:
            break;
        case CAutoUpdater::UpdateNotComplete:
            buf = m_Helper.MyLoadString(IDS_UPDATEKO);
            AfxMessageBox(buf, MB_ICONINFORMATION | MB_OK);
            break;
        case CAutoUpdater::NoExecutableVersion:
            buf = m_Helper.MyLoadString(IDS_UPDATENOEXECUTABLEVERSION);
            AfxMessageBox(buf, MB_ICONINFORMATION | MB_OK);
            break;
        default:
            buf = m_Helper.MyLoadString(IDS_UPDATECONNECTFAILED);
            AfxMessageBox(buf, MB_ICONINFORMATION | MB_OK);
            break;
    }
}

void CAboutDlg::OnButtonWhatNew()
{
    CWhatNewDlg what;
    what.DoModal();
}

BOOL CAboutDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_ABOUT);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_MAIL);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_HOMEPAGE);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_UPDATENOW);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_WHATNEW);
    m_Helper.translateDlgItemText(this, IDOK);
    CString title, version;
    GetWindowText(title);
    version.Format(_T("%s %d.%d.%d.%d"), title, VERSION_MAJOR, VERSION_MINOR, VERSION_BUILD, VERSION_QFE);
    SetWindowText(version);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CAboutDlg::OnEraseBkgnd(CDC* pDC)
{
    CPaintDC dc(this);
    CRect rcPlaceholder;
    ASSERT(dc);
    CRect rcClient;
    GetClientRect(rcClient);

    MARGINS marGlassInset =
    {
        -1, -1, -1, -1
    };

    GetDlgItem(IDC_ABOUTCTRL)->GetWindowRect(rcPlaceholder);
    ::ScreenToClient(m_hWnd, rcPlaceholder);

    marGlassInset.cxLeftWidth = rcPlaceholder.left;
    marGlassInset.cxRightWidth = rcClient.right - rcPlaceholder.right;
    marGlassInset.cyBottomHeight = rcClient.bottom - rcPlaceholder.bottom;
    marGlassInset.cyTopHeight = rcPlaceholder.top;



    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled() && SUCCEEDED(dwmApi.DwmExtendFrameIntoClientArea(m_hWnd, &marGlassInset)))
    {
        RECT rcScratch = rcClient;
        rcScratch.right = marGlassInset.cxLeftWidth;
        CPaintDC::FromHandle(dc)->PatBlt(rcScratch.left, rcScratch.top, rcScratch.right - rcScratch.left, rcScratch.bottom - rcScratch.top, BLACKNESS);
        rcScratch = rcClient;
        rcScratch.bottom = marGlassInset.cyTopHeight;
        CPaintDC::FromHandle(dc)->PatBlt(rcScratch.left, rcScratch.top, rcScratch.right - rcScratch.left, rcScratch.bottom - rcScratch.top, BLACKNESS);

        rcScratch = rcClient;
        rcScratch.left = rcScratch.right - marGlassInset.cxRightWidth;
        CPaintDC::FromHandle(dc)->PatBlt(rcScratch.left, rcScratch.top, rcScratch.right - rcScratch.left, rcScratch.bottom - rcScratch.top, BLACKNESS);

        rcScratch = rcClient;
        rcScratch.top = rcScratch.bottom - marGlassInset.cyBottomHeight;
        CPaintDC::FromHandle(dc)->PatBlt(rcScratch.left, rcScratch.top, rcScratch.right - rcScratch.left, rcScratch.bottom - rcScratch.top, BLACKNESS);
        return TRUE;
    }
    return CDialog::OnEraseBkgnd(pDC);
}
