#include "stdafx.h"
#include "desktopCalendar.h"
#include "MainHelperQ.h"
#include "SettingsDialog.h"
#include "GdiplusWrapper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CDesktopCalendarApp

// CDesktopCalendarApp construction

CDesktopCalendarApp::CDesktopCalendarApp()
{
}

int CDesktopCalendarApp::ExitInstance()
{
    delete afxContextMenuManager;
    return CWinAppEx::ExitInstance();
}

// The one and only CDesktopCalendarApp object

CDesktopCalendarApp theApp;
CSettingsDialog* SettingsDialog;

// CDesktopCalendarApp initialization

BOOL CDesktopCalendarApp::InitInstance()
{
    GdiplusStartupInput gdiplusStartupInput;
    ULONG_PTR gdiplusToken;

    // InitCommonControls() is required on Windows XP if an application
    // manifest specifies use of ComCtl32.dll version 6 or later to enable
    // visual styles.  Otherwise, any window creation will fail.
    InitCommonControls();

    SetRegistryKey(_T(""));

    InitContextMenuManager();

    CoInitialize(NULL);

    // Initialize GDI+.
    // GDI+ is used to show the thumbnail previews.
    if (GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL) != Ok)
    {
        AfxMessageBox(m_Helper.MyLoadString(IDS_LOADERROR));
        return FALSE;
    }
    else
    {
        CWinAppEx::InitInstance();

        helperMod = m_hInstance;

        SettingsDialog = new CSettingsDialog();
        m_pMainWnd = SettingsDialog;

        SettingsDialog->DoModal();

        delete SettingsDialog;
    }

    // shutdown GdiPlus
    GdiplusShutdown(gdiplusToken);

    CoUninitialize();

    return FALSE;
}
